glibmm 2.88.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::FilenameCompleter Class Reference

Completes partial file and directory names given a partial string by looking in the file system for clues. More...

`#include <giomm/filenamecompleter.h>`

Inheritance diagram for Gio::FilenameCompleter:
[legend]

## Public Member Functions
| FilenameCompleter (FilenameCompleter &&src) noexcept
FilenameCompleter & | operator= (FilenameCompleter &&src) noexcept
| ~FilenameCompleter () noexcept override
GFilenameCompleter * | gobj ()
| Provides access to the underlying C GObject.
const GFilenameCompleter * | gobj () const
| Provides access to the underlying C GObject.
GFilenameCompleter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
std::string | get_completion_suffix (const std::string &initial_text) const
| Obtains a suffix completion for initial_text from completer.
std::vector< Glib::ustring > | get_completions (const std::string &initial_text) const
| Gets an array of completion strings for a given initial text.
void | set_dirs_only (bool dirs_only=true)
| If dirs_only is `true`, completer will only complete directory names, and not file names.
Glib::SignalProxy< void()> | signal_got_completion_data ()
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data_with_c_callback (const Quark & key, void *data, GDestroyNotify notify)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< FilenameCompleter > | create ()

## Protected Member Functions
| FilenameCompleter ()
virtual void | on_got_completion_data ()
| This is a default handler for the signal signal_got_completion_data().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char *custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info &custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::FilenameCompleter > | wrap (GFilenameCompleter *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Completes partial file and directory names given a partial string by looking in the file system for clues.

Can return a list of possible completion strings for widget implementation.

Since glibmm 2.16:

## Constructor & Destructor Documentation

## ◆ FilenameCompleter() [1/2]

Gio::FilenameCompleter::FilenameCompleter | ( | FilenameCompleter && | src | ) |
| noexcept

## ◆ ~FilenameCompleter()

Gio::FilenameCompleter::~FilenameCompleter | ( |  | ) |
| override noexcept

## ◆ FilenameCompleter() [2/2]

Gio::FilenameCompleter::FilenameCompleter | ( |  | ) |
| protected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< FilenameCompleter > Gio::FilenameCompleter::create | ( |  | ) |
| static

## ◆ get_completion_suffix()

std::string Gio::FilenameCompleter::get_completion_suffix | ( | const std::string & | initial_text | ) | const

Obtains a suffix completion for initial_text from completer.

Suffix will be an empty string if there's no shared suffix among matching completions. If there's no matching completions anyway, `nullptr` is returned.

Parameters

  initial_text | Text to be completed.

Returns
  A suffix completion string, or `nullptr` if no completion exists.

## ◆ get_completions()

std::vector< Glib::ustring > Gio::FilenameCompleter::get_completions | ( | const std::string & | initial_text | ) | const

Gets an array of completion strings for a given initial text.

Parameters

  initial_text | Text to be completed.

Returns
  Array of strings with possible completions for initial_text.

## ◆ get_type()

static GType Gio::FilenameCompleter::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GFilenameCompleter * Gio::FilenameCompleter::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GFilenameCompleter * Gio::FilenameCompleter::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GFilenameCompleter * Gio::FilenameCompleter::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ on_got_completion_data()

virtual void Gio::FilenameCompleter::on_got_completion_data | ( |  | ) |
| protected virtual

This is a default handler for the signal signal_got_completion_data().

## ◆ operator=()

FilenameCompleter & Gio::FilenameCompleter::operator= | ( | FilenameCompleter && | src | ) |
| noexcept

## ◆ set_dirs_only()

void Gio::FilenameCompleter::set_dirs_only | ( | bool | dirs_only = `true` | ) |

If dirs_only is `true`, completer will only complete directory names, and not file names.

This function needs to be called before waiting for results from the completer to be populated.

Parameters

  dirs_only | A `bool`.

## ◆ signal_got_completion_data()

Glib::SignalProxy< void()> Gio::FilenameCompleter::signal_got_completion_data | ( |  | ) |

Slot Prototype:
  `void on_my_got_completion_data()`

Flags: Run Last

Emitted when the file name completion information comes available.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::FilenameCompleter > wrap | ( | GFilenameCompleter * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.